@Filename: MatQub.s
@Part: ADuC702x.
@Created: 15/04/2004
@Updated: 28/06/2005
@Author: Eckart Hartmann.
@This file is in experimental stage. The idea is to bave 
@ functions that work with normalised analog values.
@Consider a motor with full scale current I and full scale
@ voltage V then the power should be P = I*V should also 
@ be full scale.
@We choose full scale to be 0x0fffffff irrespective of
@ what the value represents.
@int MatMul(int I, int V) illustrates this nicely. Full 
@ scale is 28 bits so we reduce I and V to 14 bits and 
@ multiply to get a result which is again 28 significant
@ bits as required. i.e P = MatMul(I,V); is equivalent to 
@ P = (I>>14)*(V>>14); for I and V positive.

@ MatQub==========Calculates the 3rd power of a value.
@ C Function prototype: int MatQub(int iValue);
@ iValue:{0-0x0fffffff}     //Value to cube.
@ Description of Function: Calculates the qube of an analog value.
@ User interface: Set iValue to the value to be qubed.
@       iValue must be normalised so that 0x0fffffff is full scale.
@           Call MatQub().
@       Returns iValue*iValue*iValue normalised so that 0x0fffffff is full scale.
@ Robustness:  Works for positive iValue only.
@ Side effects: Corrupts r1 and r3.

.include        "ADuC7020.equ"
.ARM

.GLOBAL MatQub
MatQub: mov     r1,r0,LSR#19            @Shift to normalise result.
        mul     r3,r1,r1                @Square.
        mov     r1,r0,LSR#18            @shift to normalize result
        mul     r0,r1,r3
        bx      lr                      @return
